# Readme

This project uses the [sbt](http://www.scala-sbt.org/) tool for
building execution. Please refer to sbt's website for platform-specific
installation instructions.

To compile and run the program, execute `sbt "run <arguments>"`. Pass
`-h` to the program to get an overview of the available command-line
options.

Running the program on APK files requires the correct version of
the Android Platform libraries installed. Refer to the Android
documentation for installation instructions for the Android SDK.
The path to the Android SDK installation can be specified
using the command-line flag `-s`.

Moreover, the tool assumes that a key named `androiddebugkey` for
signing jar files has been created with the default passphrase
`android` under the path `$HOME/.android/debug.keystore`. If any of
these settings differ, `resign.sh` needs to be modified accordingly.

# Dependencies

The implementation relies on various external tools to function;
these must be installed separately:

- The jar files `smali-2.1.0.jar` and `baksmali-2.1.0.jar` must be
  placed in the implementation's root directory. These files are
  available on the
  [baksmali website](https://github.com/JesusFreke/smali).
- `apktool` and `xmlstarlet` need to be available on the system
  and included in the `$PATH` variable. Refer to your distribution's
  package manager for installation instructions.
- The Android development tools have to be installed and included
  in the `$PATH` variable.

# Caveats

- The implementation has only been tested on Linux systems.

# License information

DroidFace is released under BSD license. Refer to the `LICENSE` file
for details.

This tool ships with [soot](http://sable.github.io/soot/) analysis
framework; for license information on soot, please consult the soot
homepage.
